"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MonacoInput = void 0;
var react_1 = __importStar(require("react"));
var react_2 = __importDefault(require("@monaco-editor/react"));
var react_3 = require("@designable/react");
var expression_1 = require("./expression");
var format_1 = require("./format");
var chrome_1 = __importDefault(require("./themes/chrome"));
var monokai_1 = __importDefault(require("./themes/monokai"));
var classnames_1 = __importDefault(require("classnames"));
require("./styles.less");
var MonacoInput = function (_a) {
    var className = _a.className, language = _a.language, defaultLanguage = _a.defaultLanguage, width = _a.width, height = _a.height, onMount = _a.onMount, onChange = _a.onChange, props = __rest(_a, ["className", "language", "defaultLanguage", "width", "height", "onMount", "onChange"]);
    var _b = __read(react_1.useState(''), 2), errors = _b[0], setErrors = _b[1];
    var _c = __read(react_1.useState(false), 2), mounted = _c[0], setMounted = _c[1];
    var input = props.value || props.defaultValue;
    var _d = __read(react_1.useState(input), 2), value = _d[0], setValue = _d[1];
    var theme = react_3.useTheme();
    var valueRef = react_1.useRef('');
    var monacoRef = react_1.useRef();
    var changedRef = react_1.useRef(false);
    var editorRef = react_1.useRef();
    var prefix = react_3.usePrefix('monaco-input');
    react_1.useEffect(function () {
        if (input !== undefined) {
            format_1.format(input, language || defaultLanguage).then(function (prettyCode) {
                setValue(prettyCode);
            }, function (e) {
                setErrors(e === null || e === void 0 ? void 0 : e.message);
            });
        }
    }, [input]);
    react_1.useEffect(function () {
        if (monacoRef.current) {
            monacoRef.current.editor.setTheme(theme === 'dark' ? 'monokai' : 'chrome-devtools');
        }
    }, [theme, mounted]);
    valueRef.current = value;
    return (react_1.default.createElement("div", { className: classnames_1.default(prefix, className), style: { width: width, height: height } },
        react_1.default.createElement(react_2.default, __assign({}, props, { defaultLanguage: defaultLanguage, language: language, value: value, width: "100%", height: "100%", onMount: function (editor, monaco) {
                monacoRef.current = monaco;
                editorRef.current = editor;
                onMount === null || onMount === void 0 ? void 0 : onMount(editor, monaco);
                expression_1.registerExpression(language, editor, monaco);
                monaco.editor.defineTheme('monokai', monokai_1.default);
                monaco.editor.defineTheme('chrome-devtools', chrome_1.default);
                monaco.languages.typescript.typescriptDefaults.setCompilerOptions({
                    target: monaco.languages.typescript.ScriptTarget.Latest,
                    allowNonTsExtensions: true,
                    moduleResolution: monaco.languages.typescript.ModuleResolutionKind.NodeJs,
                    module: monaco.languages.typescript.ModuleKind.CommonJS,
                    noEmit: true,
                    esModuleInterop: true,
                    jsx: monaco.languages.typescript.JsxEmit.React,
                    reactNamespace: 'React',
                    allowJs: true,
                });
                monaco.languages.typescript.typescriptDefaults.setDiagnosticsOptions({
                    noSemanticValidation: false,
                    noSyntaxValidation: false,
                });
                setMounted(true);
            }, onValidate: function (markers) {
                if (markers.length) {
                    var marker = markers[0];
                    setErrors("[" + marker.code + "]: " + marker.message + "  " + marker.startLineNumber + ":" + marker.startColumn);
                }
                else if (changedRef.current) {
                    onChange === null || onChange === void 0 ? void 0 : onChange(valueRef.current);
                    setErrors('');
                }
            }, onChange: function (value) {
                changedRef.current = true;
                valueRef.current = value;
            } })),
        errors && (react_1.default.createElement("div", { className: prefix + '-errors' },
            react_1.default.createElement("code", null,
                react_1.default.createElement("pre", null, errors))))));
};
exports.MonacoInput = MonacoInput;
